<?xml version="1.0" encoding="UTF-8"?>
<refentry version="5.0-subset Scilab" xml:id="cuter_bench" xml:lang="en"
          xmlns="http://docbook.org/ns/docbook"
          xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:svg="http://www.w3.org/2000/svg"
          xmlns:ns5="http://www.w3.org/1999/xhtml"
          xmlns:mml="http://www.w3.org/1998/Math/MathML"
          xmlns:db="http://docbook.org/ns/docbook">
  <info> 
    <pubdate>17-Mar-2003</pubdate>
  </info>

  <refnamediv>
    <refname>cuter_bench</refname>

    <refpurpose>benchmarks solvers against CUTEr problem collection function</refpurpose>
  </refnamediv>

  <refsynopsisdiv>
    <title>Calling Sequence</title>

    <synopsis>cuter_bench(result_file [,solvers])</synopsis>
  </refsynopsisdiv>

  <refsection>
    <title>Parameters</title>

    <variablelist>
      <varlistentry>
        <term>result_file</term>

        <listitem>
          <para>A string: the path of the result file </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>sovers</term>

        <listitem>
          <para>A string vector, the names of the solvers</para>
        </listitem>
      </varlistentry>

    
    </variablelist>
  </refsection>

  <refsection>
    <title>Description</title>

    <para><literal>cuter_bench(result_file)</literal> stores in the
    file given by <literal>result_file</literal> the result tables for
    the solvers  <literal>ipopt</literal>,
    <literal>optimqn</literal>, <literal>optimgc</literal>,
    <literal>fsqpal</literal>, <literal>fsqpnl</literal>,
    <literal>qld</literal>, <literal>qpsolve</literal>,
    <literal>quapro</literal></para>
    <para>The results for the solver
    <literal>&lt;solver_name&gt;</literal> are stored in a data
    structure named <literal>Res_&lt;solver_name&gt;</literal>. Each
    row of the data structure contains the results for a CUTEr
    problem. The data fields depends on the solver but there is at
    least : the optimal objective found (<literal>Cost</literal>,the
    feasibility norm (<literal>feas</literal>), the lagrangian norm
    (<literal>glagn</literal>), the dual feasibility norm
    (<literal>comp_val</literal>), the cpu time
    (<literal>Time</literal>) and a failure indicator
    (<literal>Fail</literal>). If relevant, the number of objective
    function calls (<literal>Nf</literal>) and the number of gradient
    of objective function calls (<literal>Ng</literal>) are also
    reported.</para>
    <para><literal>cuter_bench(result_file,solvers)</literal> can be used to specify a subset of the solvers.</para>
  </refsection>
  <refsection>
    <title>Adding a new solver</title>
    <para>To add a new Scilab solver one must create:</para>
    <itemizedlist>
      <listitem>
	<para>The external functions required to fit the solver requirements (see <link linkend="ipopt_obj">ipopt_obj</link>, <link linkend="ipopt_grobj">ipopt_obj</link>, <link linkend="ipopt_cntr">ipopt_cntr</link> and  <link linkend="ipopt_grcntr">ipopt_cntr</link> as examples).</para>
      </listitem>

      <listitem>
	<para>The <literal>test_xxxx</literal> function that
	applies the solver to a given problem (see <literal>test_ipopt.sci</literal> as an
	example).</para>
      </listitem>

      <listitem>
	<para>The <literal>benchxxxx</literal> fonction that
	creates and sets the result data structure dedicated the
	solver(see  <literal>benchipopt.sci</literal> as an
	example).</para>
      </listitem>
    </itemizedlist>
    
  </refsection>
  <refsection>
    <title>Authors</title>

    <simplelist type="vert">
      <member>Serge Steer, INRIA</member>
    </simplelist>
  </refsection>

  
</refentry>
